Program Proboj;
  Uses Typy,Grafika,Crt,Hrac1,Hrac2,Hrac3,Hrac4,Hrac5;

{############################################################################}
{########################< VNUTORNE POLIA >##################################}
{############################################################################}

  Var {Tahy jednotlivych hracov}
      Tahaj:Array[1..Hracov] Of ProcTahaj;
      Init :Array[1..Hracov] Of ProcInit;
      {Interny Mravci a Mraveniska}
      Mravcekovia:Array[1..Hracov] Of Mravce;
      Mraveniska:Array[1..Hracov] Of Mravenisko;
      {Interne Ihrisko}
      Svet:Ihrisko;
      {Nazbierane body}
      Body:Vysledok;
      {Celkovy vysledok}
      Celkovo:Vysledok;

{############################################################################}
{########################<    PROCEDURY    >#################################}
{############################################################################}

  {Vygeneruj Svet}
  Procedure Vygeneruj;
    Var i,j,k:Integer;
        pom, pom1: integer;
        perm: array[1..Hracov] of integer;
        Nalezisk, Nx, Ny, SizeX, SizeY: integer;

    function Vyhovuje(Nx, Ny, SizeX, SizeY: integer): boolean;
      var i: integer;
      begin
        Vyhovuje := false;
        for i:=1 to Hracov do
          if (Mraveniska[i].x > Nx - JBlizko) and
             (Mraveniska[i].x < Nx +SizeX + JBlizko) and
             (Mraveniska[i].y > Ny - JBlizko) and
             (Mraveniska[i].y < Ny +SizeY + JBlizko)  then exit;
        Vyhovuje:= true;
      end;

    Begin
      For i:=1 To IhriskoX Do Begin
        For j:=1 To IhriskoY Do Begin
          Svet[i,j].Cis:=Nic;
        End
      End;

      for i:=1 to Hracov do
        perm[i]:=i;

      for i:=Hracov downto 2 do begin
        pom:=perm[i];
        pom1:=random(i)+1;
        perm[i]:=perm[pom1];
        perm[pom1]:=pom;
      end;

      {Umiestnime mraveniska}
      Mraveniska[perm[1]].X:=10+random(20);
      Mraveniska[perm[1]].Y:=10+random(20);
      Mraveniska[perm[2]].X:=IhriskoX-10-random(20);
      Mraveniska[perm[2]].Y:=10+random(20);
      Mraveniska[perm[3]].X:=10+random(20);
      Mraveniska[perm[3]].Y:=IhriskoY-10-random(20);
      Mraveniska[perm[4]].X:=IhriskoX-10-random(20);
      Mraveniska[perm[4]].Y:=IhriskoY-10-random(20);
      Mraveniska[perm[5]].X:=IhriskoX div 2 -15 + random(30);
      Mraveniska[perm[5]].Y:=IhriskoY div 2 -10 + random(20);

      {Hodime tam potravu}
      Nalezisk := NMConst*Hracov+random(NAConst);
      for i:=1 to Nalezisk do begin
          repeat
            Nx:=random(IhriskoX-10)+5;
            Ny:=random(IhriskoY-10)+5;
            SizeX:= 4+random(NSizeXConst);
            SizeY:= 4+random(NSizeYConst);
          until Vyhovuje(Nx, Ny, SizeX, SizeY);

          if Nx+SizeX>IhriskoX then SizeX:=IhriskoX-Nx;
          if Ny+SizeY>IhriskoY then SizeY:=IhriskoY-Ny;

          For j:=Nx To Nx+SizeX Do
            For k:=Ny To Ny+SizeY Do
              Svet[j][k].Cis:=Jedlo;
      end;

{      Case (Random(2)) Of
        0:Begin
          For i:=40 To IhriskoX-40 Do Begin
            For j:=25 To IhriskoY-25 Do Begin
              Svet[i,j].Cis:=Jedlo;
            End;
          End;
        End;
        1:Begin
          For i:=1 To IhriskoX Do Begin
            For j:=1 To 10 Do Begin
              Svet[i][j].Cis:=Jedlo;
            End;
            For j:=IhriskoY-10 To IhriskoY Do Begin
              Svet[i][j].Cis:=Jedlo;
            End;
          End;
        End;
      End;
 }
      {Aj mraveniska tam hodime}
      For i:=1 To Hracov Do Begin
        Svet[Mraveniska[i].X,Mraveniska[i].Y].Cis:=Mravenko;
        Svet[Mraveniska[i].X,Mraveniska[i].Y].Hrac:=i;
      End;
    End;

  {Urob jeden tah}
  Procedure JedenTah;
    Var i,j,k,l,x,y,c,h,ox,oy:Integer;
        Kam:Pohyb;
        Coo:Kupa;

    Begin
      For i:=1 To Hracov Do Begin
        {Najprv spravime jeho panacikom pohlady}
        For j:=1 To Mravcov Do If (Mravcekovia[i][j].Zivy) Then Begin
          For k:=-Dohlad To Dohlad Do Begin
            For l:=-Dohlad To Dohlad Do Begin
              x:=Mravcekovia[i][j].x+k;
              y:=Mravcekovia[i][j].y+l;
              If (x>=1) And (x<=IhriskoX) And (y>=1) And (y<=IhriskoY) Then Begin
                c:=Svet[x][y].Cis;
                h:=Svet[x][y].Hrac;
                If (c<=0) Then
                  Mravcekovia[i][j].Vidi[k][l]:=c
                Else
                  If (h=i) Then
                    Mravcekovia[i][j].Vidi[k][l]:=Kamarat
                  Else
                    Mravcekovia[i][j].Vidi[k][l]:=Mravcekovia[h][c].Typ;
              End Else
                Mravcekovia[i][j].Vidi[k][l]:=Okraj;
            End;
          End;
        End;

        {Nastavime Tahy na 0}
        For j:=1 To Mravcov Do Begin
          Kam[j].Dx:=0;
          Kam[j].Dy:=0;
        End;
        Coo:=0;

        {Nech potiahne}
        Tahaj[i](Mravcekovia[i],Body[i],Kam,Coo);
        {Teraz potiahneme jeho panacikov}
        For j:=1 To Mravcov Do Begin
          If (Mravcekovia[i][j].Zivy) Then Begin
            Case Mravcekovia[i][j].Typ Of
              Robotnik:Begin
                If (Abs(Kam[j].Dx)+Abs(Kam[j].Dy))=1 Then Begin
                  ox:=Mravcekovia[i][j].x;
                  oy:=Mravcekovia[i][j].y;
                  x:=ox+Kam[j].Dx;
                  y:=oy+Kam[j].Dy;
                  If (x>=1) And (x<=IhriskoX) And (y>=1) And (y<=IhriskoY) Then Begin
                    Case (Svet[x][y].Cis) Of
                      Nic:Begin
                        {Pohne sa tam}
                        Mravcekovia[i][j].x:=x;
                        Mravcekovia[i][j].y:=y;
                        Svet[x][y].Cis:=j;
                        Svet[x][y].Hrac:=i;
                        If Svet[ox][oy].Cis<>Mravenko Then Begin
                          Svet[ox][oy].Cis:=0;
                          VymazPolicko(ox,oy);
                        End;
                        NakresliPolicko(x,y,i,Robotnik);
                      End;
                      Jedlo:If (Not Mravcekovia[i][j].Nesie) Then Begin
                        {Zozerie ho}
                        Mravcekovia[i][j].x:=x;
                        Mravcekovia[i][j].y:=y;
                        Mravcekovia[i][j].Nesie:=True;
                        Svet[x][y].Cis:=j;
                        Svet[x][y].Hrac:=i;
                        If Svet[ox][oy].Cis<>Mravenko Then Begin
                          Svet[ox][oy].Cis:=0;
                          VymazPolicko(ox,oy);
                        End;
                        VymazPolicko(x,y);
                        NakresliPolicko(x,y,i,Robotnik);
                      End;
                      Mravenko:Begin
                        {Vlezie dnu a odovzda jedlo}
                        If (Svet[x][y].Hrac=i) Then Begin
                          Mravcekovia[i][j].x:=x;
                          Mravcekovia[i][j].y:=y;
                          Svet[ox][oy].Cis:=0;
                          VymazPolicko(ox,oy);
                          If (Mravcekovia[i][j].Nesie) Then Begin
                            Mravcekovia[i][j].Nesie:=False;
                            Body[i]:=Body[i]+1;
                          End;
                        End;
                      End;
                    End;
                  End;
                End;
              End;
              Bojovnik:Begin
                If (Abs(Kam[j].Dx)<=1) And (Abs(Kam[j].Dy)<=1) Then Begin
                  ox:=Mravcekovia[i][j].x;
                  oy:=Mravcekovia[i][j].y;
                  x:=ox+Kam[j].Dx;
                  y:=oy+Kam[j].Dy;
                  If (x>=1) And (x<=IhriskoX) And (y>=1) And (y<=IhriskoY) Then Begin
                    Case (Svet[x][y].Cis) Of
                      Nic:Begin
                        {Pohne sa tam}
                        Mravcekovia[i][j].x:=x;
                        Mravcekovia[i][j].y:=y;
                        Svet[x][y].Cis:=j;
                        Svet[x][y].Hrac:=i;
                        If Svet[ox][oy].Cis<>Mravenko Then Begin
                          Svet[ox][oy].Cis:=0;
                          VymazPolicko(ox,oy);
                        End;
                        NakresliPolicko(x,y,i,Bojovnik);
                      End;
                      Jedlo:Begin
                        {Ja som mravec bojovnik a cukor NEZERIEM!!!}
                      End;
                      Mravenko:Begin
                        {Vlezie dnu}
                        If (Svet[x][y].Hrac=i) Then Begin
                          Mravcekovia[i][j].x:=x;
                          Mravcekovia[i][j].y:=y;
                          If Svet[ox][oy].Cis<>Mravenko Then Begin
                            Svet[ox][oy].Cis:=0;
                            VymazPolicko(ox,oy);
                          End;
                        end;
                        {Co som bobkac???}
                      End;
                    Else Begin
                      {Je tu nejaky mravec???}
                        h:=Svet[x][y].Hrac;
                        c:=Svet[x][y].Cis;
                        If (h<>i) Then Begin
                          Case Mravcekovia[h][c].Typ Of
                            Robotnik:Begin
                              {Mnam Robotnik!!}
                              Mravcekovia[h][c].Zivy:=False;
                              {Posuniem sa tam...}
                              Mravcekovia[i][j].x:=x;
                              Mravcekovia[i][j].y:=y;
                              Svet[x][y].Cis:=j;
                              Svet[x][y].Hrac:=i;
                              If Svet[ox][oy].Cis<>Mravenko Then Begin
                                Svet[ox][oy].Cis:=0;
                                VymazPolicko(ox,oy);
                              End;
                              VymazPolicko(x,y);
                              NakresliPolicko(x,y,i,Bojovnik);
                            End;
                            Bojovnik:Begin
                              {Hrdinsky umrieme obaja}
                              Mravcekovia[h][c].Zivy:=False;
                              Mravcekovia[i][j].Zivy:=False;
                              If Svet[ox][oy].Cis<>Mravenko Then Begin
                                Svet[ox][oy].Cis:=0;
                                VymazPolicko(ox,oy);
                              End;
                              Svet[x][y].Cis:=0;
                              VymazPolicko(x,y);
                            End;
                          End;
                        End;
                      End;
                    End;
                  End;
                End;
              End;
            End;
          End;
        End;
        {No a teraz by sme hmmm....,  mohli nakupit mravca}
        If (Coo>0) And (Body[i]>=Cena) And (Coo<=2) Then Begin
          j:=1;
          While ((j<=Mravcov) And (Mravcekovia[i][j].Zivy)) Do j:=j+1;
          If (j<=Mravcov) Then Begin
            {No tak tu ho mas...}
            Body[i]:=Body[i]-Cena;
            Mravcekovia[i][j].Zivy:=True;
            Mravcekovia[i][j].X:=Mraveniska[i].X;
            Mravcekovia[i][j].Y:=Mraveniska[i].Y;
            Mravcekovia[i][j].Typ:=Coo;
            Mravcekovia[i][j].Nesie:=False;
          End;
        End;
      End;
      {Vypis nove body}
      VypisNoveBody(Body);
    End;

 {Odohraj jednu hru}
 Procedure Hra;
   Var i,j:Integer;
   Begin
     For i:=1 To Hracov Do Body[i]:=0;
     {Nastav Panacikov}
     For i:=1 To Hracov Do Begin
       For j:=1 To Mravcov Do Begin
         {Nastavime im suradnice}
         Mravcekovia[i][j].X:=Mraveniska[i].X;
         Mravcekovia[i][j].Y:=Mraveniska[i].Y;
         {Dve tretimy su zive}
         Mravcekovia[i][j].Zivy:=(j<=(2*Mravcov Div 3));
         Mravcekovia[i][j].Nesie:=False;
         {Jedna tretina su robotnici}
         If (j<=Mravcov Div 3) Then
           Mravcekovia[i][j].Typ:=Robotnik
         Else
           Mravcekovia[i][j].Typ:=Bojovnik;
       End;
     End;
     {Spusti im inity}
     For i:=1 To Hracov Do
       Init[i](Mraveniska[i]);
     {A sprav TahovNaHru tahov}
     i:=1;
     while (i<TahovNaHru) Do Begin
       Jedentah;
       inc(i);
     End;
   End;

 {Odohraj Turnaj}
 Procedure Turnaj;
   Var i,j,k,h,c,t:Integer;

   Begin
     For i:=1 To Hracov Do
       Celkovo[i]:=0;
     For i:=1 To Zapasov Do Begin
       {Vygneruj hraci planik}
       Vygeneruj;
       {Nakresli ihrisko}
       NakresliIhrisko;
       {Vykreslime Policka}
       For j:=1 To IhriskoX Do Begin
         For k:=1 To IhriskoY Do Begin
           h:=Svet[j][k].Hrac;
           c:=Svet[j][k].Cis;
           If (c>0) Then
             t:=Mravcekovia[h][c].Typ
           Else
             t:=c;

           NakresliPolicko(j,k,h,t);
         End;
       End;
       {Zahraj hru}
       Hra;
       {A oznam vysledok}
       OznamVysledok(Body);
       {A pripocitaj vysledok}
       For j:=1 to Hracov Do
         Celkovo[j]:=Celkovo[j]+Body[j];
     End;
     KoniecTurnaja(Celkovo);
   End;

Begin
{  Randseed:=1993;}
  Randomize;
  Tahaj[1]:=Hrac1.Tahaj; Init[1]:=Hrac1.Init;
  Tahaj[2]:=Hrac2.Tahaj; Init[2]:=Hrac2.Init;
  Tahaj[3]:=Hrac3.Tahaj; Init[3]:=Hrac3.Init;
  Tahaj[4]:=Hrac4.Tahaj; Init[4]:=Hrac4.Init;
  Tahaj[5]:=Hrac5.Tahaj; Init[5]:=Hrac5.Init;
  Inicializuj;
  Turnaj;
End.