  Unit hrac5;

  Interface
    Uses typy;

    Const Cislo=1;
    Const VELA = 10000;
          OCHRANCOV = 2;
          VOLNA_NOHA = 6;
          BLIZO = 14;
          CIEL_TIK = 15;
          HLADOVKA = 40;

          JE_JEDLO = 1;
          JE_ROBOTNIK = 2;
          JE_BOJOVNIK = 4;

    Procedure Init(A:Mravenisko);
    Procedure Tahaj(M:Mravce;Body:Integer;Var Tah:Pohyb;Var Novy:Kupa);

  Implementation

    Var X,Y, Ox,Oy:Array[1..Mravcov] Of Integer;
        MaCiel: Array[1..Mravcov] of boolean;
        B :Mravenisko;
        CM: array[1..Hracov-1] of Mravenisko;
        PCM: integer;

        Cas, Jedol: integer;

        JeCiel: boolean;
        CielVzd: integer;
        Cx,Cy: integer;

    {Toto je iba pomocna procedura... (sori)}
    Procedure ZvolBod(Index:Integer);
      Begin
        X[Index]:=Random(IhriskoX-5)+5;
        Y[Index]:=Random(IhriskoY-5)+5;
        MaCiel[index]:=true;
      End;

    {Aj toto (ale funkcia)}
    Function Sgn(x:Integer):Integer;
      Begin
        If (x>0) Then
          Sgn:=1
        Else
          If (x<0) Then
            Sgn:=-1
          Else
            Sgn:=0;
      End;

    function max(x,y: integer): integer;
      begin
        if (x>y) then
          max:=x
        else
          max:=y
      end;

    function rvzd(x1, y1, x2, y2: integer): integer;
      begin
        rvzd:=abs(x1-x2)+abs(y1-y2)
      end;

    function bvzd(x1, y1, x2, y2: integer): integer;
      begin
        bvzd:=max(abs(x1-x2), abs(y1-y2))
      end;

    procedure rzameraj(x,y,nx,ny: integer; var D: Smer);
      begin
        D.dx:=sgn(nx-x);
        D.dy:=sgn(ny-y);
        if abs(D.dx)+abs(D.dy) > 1 then
          if (random(2) = 0) then
            D.dx:=0
          else
            D.Dy:=0;
      end;

    procedure bzameraj(x,y,nx,ny: integer; var D: Smer);
      begin
        D.dx:=sgn(nx-x);
        D.dy:=sgn(ny-y);
      end;

    procedure OsetriJedlo(Jx, Jy: integer);
      begin
        if rvzd(Jx, Jy, B.x, B.y) < (CielVzd+2) then begin
          JeCiel:=true;
          Cx:=Jx;
          Cy:=Jy;
          CielVzd:=rvzd(Jx, Jy, B.x, B.y);
        end;
      end;

    procedure OsetriMravenko(Mx, My: integer);
      var i: integer;
      begin
        if (Mx = B.x) and (My = B.y) then exit;
        for i:=1 to PCM do
          if (CM[i].x = Mx) and (CM[i].y = My) then exit;
        inc(PCM);
        CM[PCM].x := Mx;
        CM[PCM].y := My;
      end;

    procedure rPrieskum(x,y: integer; var V:Pohlad; var CoTamJe, Jx, Jy, CBx, CBy: integer);
      var i,j: integer;
          minJ, minB : integer;
      begin
        CoTamJe:=0;
        minJ:=VELA; minB:=VELA;
        for i:=-Dohlad to Dohlad do
          for j:=-Dohlad to Dohlad do
            case V[i,j] of
              Mravenko: OsetriMravenko(x+i, y+j);
              Jedlo:
                begin
                  OsetriJedlo(x+i, y+j);
                  CoTamJe := CoTamJe or JE_JEDLO;
                  if (rvzd(i,j,0,0) < minJ) then begin
                    Jx:=x+i;
                    Jy:=y+j;
                    minJ := rvzd(i,j,0,0);
                  end;
                end;
              Bojovnik:
                begin
                  CoTamJe := CoTamJe or JE_BOJOVNIK;
                  if (bvzd(i,j,0,0) < minB) then begin
                    CBx:=x+i;
                    CBy:=y+j;
                    minB := bvzd(i,j,0,0);
                  end;
                end;
          end
      end;

    procedure bPrieskum(x,y: integer; var V:Pohlad; var CoTamJe, Jx, Jy, CBx, CBy, CRx, CRy: integer);
      var i,j: integer;
          minJ, minB, minR: integer;
      begin
        CoTamJe:=0;
        minJ:=VELA; minB:=VELA; minR:=VELA;
        for i:=-Dohlad to Dohlad do
          for j:=-Dohlad to Dohlad do
            case V[i,j] of
              Mravenko: OsetriMravenko(x+i, y+j);
              Jedlo:
                begin
                  OsetriJedlo(x+i, y+j);
                  CoTamJe := CoTamJe or JE_JEDLO;
                  if (rvzd(i,j,0,0) < minJ) then begin
                    Jx:=x+i;
                    Jy:=y+j;
                    minJ := rvzd(i,j,0,0);
                  end;
                end;
              Robotnik:
                begin
                  CoTamJe := CoTamJe or JE_ROBOTNIK;
                  if (bvzd(i,j,0,0) < minR) then begin
                    CRx:=x+i;
                    CRy:=y+j;
                    minR := bvzd(i,j,0,0);
                  end;
                end;
              Bojovnik:
                begin
                  CoTamJe := CoTamJe or JE_BOJOVNIK;
                  if (bvzd(i,j,0,0) < minB) then begin
                    CBx:=x+i;
                    CBy:=y+j;
                    minB := bvzd(i,j,0,0);
                  end;
                end;
          end
      end;

    function BlizoMoj(var M:Mravce; CBx, CBy: integer): boolean;
      var i: integer;
      begin
        if bvzd(CBx, CBy, B.x, B.y) < BLIZO then begin
          BlizoMoj := true;
          exit;
        end;
        for i:=1 to Mravcov do
          if M[i].Zivy and (M[i].typ = Robotnik) and
            (bvzd(CBx, CBy, M[i].x, M[i].y) < BLIZO ) then begin
              BlizoMoj:=true;
              exit;
            end;
        BlizoMoj:=false;
      end;

    procedure ZavolajPomoc(var M:Mravce; CBx, CBy: integer);
      var i, minI, minV: integer;
      begin
        minI:=0;
        minV:=VELA;
        for i:=1 to Mravcov do
          if M[i].zivy and (M[i].typ = Bojovnik) then
            if bvzd(M[i].x, M[i].y, Cx, Cy) < minV then begin
               minV:=bvzd(M[i].x, M[i].y, Cx, Cy);
               minI:=i;
            end;
        if (minI>0) then begin
          X[minI]:=CBx;
          Y[minI]:=CBy;
          MaCiel[minI]:=true;
        end;
      end;

    {Tymto si mozte nainicializovat nejake struktury...}
    Procedure Init(A:Mravenisko);
      Var i:Integer;
      Begin
        CielVzd:=VELA;
        JeCiel:=false;
        Cas:=0;
        Jedol := 0;
        PCM:=0;
        For i:=1 To Mravcov Do begin
          ZvolBod(i);
          Ox[i]:=B.x;
          Oy[i]:=B.y;
        end;
        {Aj si zapamatame, kde mame mravenisko}
        B:=A;
      End;

    {A tymtotu potiahnete vsetkych mravcov}
    Procedure Tahaj(M:Mravce;Body:Integer;Var Tah:Pohyb;Var Novy:Kupa);
      Var i,j,k,l,w, pom:Integer;
          CoTamJe: integer;
          Jx, Jy, CBx, CBy, CRx, CRy: integer;
          zR, zB: integer;
      Begin
        inc(Cas);
        if (Cas-Jedol) > Hladovka then begin
           CielVzd:=VELA;
           JeCiel:=false;
        end;
        if (Cas mod CIEL_TIK) = 0 then inc(CielVzd);
        zR:=0;
        zB:=0;
        For i:=1 To Mravcov Do If M[i].Zivy Then Begin
          { pre istotu }
          Tah[i].Dx:=0;
          Tah[i].Dy:=0;
          {Hybeme iba so zivymi mravcami...}
          if M[i].Typ = Robotnik then begin
            {Ak mame daco, sup do mraveniska}
            inc(zR);
            If M[i].Nesie Then Begin
              X[i]:=B.X;
              Y[i]:=B.Y;
              MaCiel[i]:=false;
            End Else Begin
              {Kukaj vokol seba}
              rPrieskum(M[i].x, M[i].y, M[i].Vidi, CoTamJe, Jx, Jy, CBx, CBy);
              if (CoTamJe and JE_BOJOVNIK) <> 0 then begin
                X[i]:=B.X;
                Y[i]:=B.Y;
                MaCiel[i]:=false;
                ZavolajPomoc(M, CBx, CBy);
              end else if (CoTamJe and JE_JEDLO) <> 0 then begin
                OsetriJedlo(M[i].x+Jx, M[i].y+Jy);
                X[i]:=Jx;
                Y[i]:=Jy;
                MaCiel[i]:=false;
                Jedol:=Cas;
              end else if JeCiel then begin
                X[i]:=CX+random(6)-3;
                Y[i]:=CY+random(6)-3;
                MaCiel[i]:=false;
              end else if not MaCiel[i] then
                ZvolBod(i);
            end;
            { transformacia cieloveho miesta na vektor pohybu }
            rZameraj(M[i].x, M[i].y, X[i], Y[i], Tah[i]);

            { Ak tam kde chcem ist je kamarat, tak uhnem}
            If (M[i].Vidi[Tah[i].Dx,Tah[i].Dy]=Kamarat) Then
              if (random(2)=0) then begin
                pom:=Tah[i].Dx;
                Tah[i].Dx:=-Tah[i].Dy;
                Tah[i].Dy:=pom
              end else begin
                pom:=Tah[i].Dx;
                Tah[i].Dx:=Tah[i].Dy;
                Tah[i].Dy:=-pom
              end;
          End;
        end;

        For i:=1 To Mravcov Do If M[i].Zivy Then
            {Bojovnik aj sikmo}
            if M[i].typ = Bojovnik then Begin
              inc(zB);
              {Kukaj vokol seba}
              bPrieskum(M[i].x, M[i].y, M[i].Vidi, CoTamJe, Jx, Jy, CBx, CBy, CRx, CRy);
              if (CoTamJe and JE_ROBOTNIK) <> 0 then begin
                  X[i]:=CRx;
                  Y[i]:=CRy;
                  MaCiel[i]:=false;
              end else if (CoTamJe and JE_BOJOVNIK) <> 0 then
                if (BlizoMoj(M, CBx, CBy)) then begin
                  X[i]:=CBx;
                  Y[i]:=CBy;
                  MaCiel[i]:=false;
                end else
              else
                if zb > OCHRANCOV then
                  if zb > VOLNA_NOHA then
                    if (MaCiel[i]) then
                    else if (PCM = 0) or (random(2) = 0) then ZvolBod(i)
                      else begin
                        pom := random(PCM)+1;
                        X[i]:=CM[pom].x+random(10)-5;
                        Y[i]:=CM[pom].y+random(10)-5;
                        MaCiel[i]:=true;
                      end
                  else if MaCiel[i] then
                    else if (bvzd(M[i].x, M[i].y, B.x, B.y) <
                        bvzd(M[i].x, M[i].y, Cx, Cy)) then begin
                        X[i]:=Cx+random(4)-2;
                        Y[i]:=Cy+random(4)-2;
                        MaCiel[i]:=true;
                      end else begin
                        X[i]:=B.x+random(4)-2;
                        Y[i]:=B.y+random(4)-2;
                        MaCiel[i]:=true;
                      end
                else begin
                  X[i]:=B.x;
                  Y[i]:=B.y;
                  MaCiel[i]:=false;
                end;

              if (CoTamJe and JE_JEDLO) <> 0 then
                OsetriJedlo(Jx, Jy);

              { transformacia cieloveho miesta na vektor pohybu }
              bZameraj(M[i].x, M[i].y, X[i], Y[i], Tah[i]);

              if MaCiel[i] and
                 ((random(10) = 0) or
                 ((M[i].x = Ox[i]) and (M[i].y = Oy[i])) or
                 ((X[i] = M[i].x) and (Y[i] = M[i].y))) then
                MaCiel[i]:=false;

              { Ak tam kde chcem ist je kamarat, tak uhnem}
              If (M[i].Vidi[Tah[i].Dx,Tah[i].Dy]=Kamarat) Then
                if (random(2)=0) then begin
                  pom:=Tah[i].Dx;
                  Tah[i].Dx:=-Tah[i].Dy;
                  Tah[i].Dy:=pom
                end else begin
                  pom:=Tah[i].Dx;
                  Tah[i].Dx:=Tah[i].Dy;
                  Tah[i].Dy:=-pom
                end;
              Ox[i]:=M[i].x;
              Oy[i]:=M[i].y;
          end;

        {Aj nakupime}
        If (Body>=9) Then Begin
          if (zR+zB) < 25 then
            if (2*zB > zR) then
              Novy := Robotnik
            else
              Novy := Bojovnik;
        End;

      End;

  Begin
  End.