Unit Typy;

Interface

{##########################################################################}
{#########################< KONSTANTY >####################################}
{##########################################################################}

Const Hracov=5;
      Mravcov=30;      {  =  Maximalny pocet mravcov }
      TahovNaHru=3000;
      Zapasov=5;
      Cena=4;          {  =  Cena za mravca }

      IhriskoX=120;    {  =  Rozmery ihriska }
      IhriskoY=75;

      Kamarat =-4;     {  =  Veci, ktore sa daju vidiet }
      Okraj   =-3;
      Mravenko=-2;
      Jedlo   =-1;
      Nic     = 0;
      Robotnik= 1;     {  =  Typy mravcov }
      Bojovnik= 2;

      Dohlad=7;        {  =  Maximalny dohlad mravca }

      Farby:Array[1..Hracov] Of Integer=(1,2,3,4,5);
      Mena:Array[1..Hracov] of String=('Bronine   ','Ivonine   ','MC-ho     ','Palenicove','Veducich  ');

{##########################################################################}
{#########################<   TYPY    >####################################}
{##########################################################################}

Type {<<<<<<< Externe typy >>>>>>>}

     { Ake veci sa mozu vyskytovat na planiku: }
     {  0      - Nic                           }
     { -1      - Jedlo                         }
     { -2      - Mravenisko                    }
     { -3      - Okraj                         }
     { -4      - Priatelsky mravec             }
     { >0      - Typ nepriatelskeho mravca     }
     Veci=ShortInt;

     {Aky mravci sa daju kupit}
     {  0      - Nic                           }
     { >0      - Typ Mravca                    }
     Kupa=ShortInt;

     {Pohlad jedneho mravca:}
     Pohlad=Array[-Dohlad..Dohlad,-Dohlad..Dohlad] Of Veci;

     {Vlastnosti jedneho mravca:}
     Mravec=Record
       Zivy :Boolean;            { Ci je mravec zivy, no ne? }
       Nesie:Boolean;            { Ci nesie zranicu (iba Robotnik) }
       Typ  :Integer;            { Typ mravca = Robotnik/Bojovnik }
       X,Y  :Integer;            { Suradnice (podla cuchu) }
       Vidi :Pohlad;             { A Co vidi okolo seba }
     End;

     {Kam sa ma pohnut mravec:}
     Smer=Record
       Dx,Dy:Integer;
     End;

     {Vela mravcov:}
     Mravce=Array[1..Mravcov] Of Mravec;

     {Kam sa ma pohnut vela mravcov:}
     Pohyb=Array[1..Mravcov] Of Smer;

     {Suradnice mraveniska:}
     Mravenisko=Record
       X,Y:Integer;
     End;

     {Typy procedur, ktore treba spravit:}
     ProcTahaj=Procedure(M:Mravce;Body:Integer;Var Tah:Pohyb;Var Novy:Kupa);
     ProcInit =Procedure(A:Mravenisko);

     {<<<<<<< Interne typy >>>>>>>}
const JBlizko = 10;
      NMConst = 2;
      NAConst = 6;
      NSizeXConst = 16;
      NSizeYConst = 10;

type     {Vysledky hry}
     Vysledok=Array[1..Hracov] Of Integer;

     {Jedno vnutorne policko:}
     { -2 = Mravenisko       }
     { -1 = Jedlo            }
     {  0 = Nic              }
     { >0 = Cislo mravca     }
     Policko=Record
       Cis :ShortInt;
       Hrac:ShortInt;
     End;

     Ihrisko=Array[1..IhriskoX,1..IhriskoY] Of Policko;

Implementation

Begin
End.